
/*  A Bison parser, made from grammar.y
 by  GNU Bison version 1.25
  */

#define YYBISON 1  /* Identify Bison output.  */

#define	MICROCODE	258
#define	MACROCODE	259
#define	MAP	260
#define	BANK	261
#define	FIELD	262
#define	REGISTERS	263
#define	OPERANDS	264
#define	OP	265
#define	KWBEGIN	266
#define	KWEND	267
#define	NL	268
#define	SEMI	269
#define	COLON	270
#define	COMMA	271
#define	ASGN	272
#define	HASH	273
#define	TILDE	274
#define	PERCENT	275
#define	PLUS	276
#define	AT	277
#define	BOGOCHAR	278
#define	MINUS	279
#define	LBRACE	280
#define	RBRACE	281
#define	LPAREN	282
#define	RPAREN	283
#define	LBRACK	284
#define	RBRACK	285
#define	DSHORT	286
#define	DLONG	287
#define	DBYTE	288
#define	DSYMBOL	289
#define	DBSS	290
#define	DPROC	291
#define	DEND	292
#define	NUMBER	293
#define	LITERAL	294
#define	REGISTER	295
#define	STRING	296

#line 39 "grammar.y"

#include "grammar.h"
#include "parser.h"
#include <stdio.h>

#ifndef __cplusplus
#ifndef __STDC__
#define const
#endif
#endif



#define	YYFINAL		231
#define	YYFLAG		-32768
#define	YYNTBASE	42

#define YYTRANSLATE(x) ((unsigned)(x) <= 296 ? yytranslate[x] : 100)

static const char yytranslate[] = {     0,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     2,     2,     2,     2,     2,     1,     2,     3,     4,     5,
     6,     7,     8,     9,    10,    11,    12,    13,    14,    15,
    16,    17,    18,    19,    20,    21,    22,    23,    24,    25,
    26,    27,    28,    29,    30,    31,    32,    33,    34,    35,
    36,    37,    38,    39,    40,    41
};

#if YYDEBUG != 0
static const short yyprhs[] = {     0,
     0,     2,     5,     7,     9,    11,    13,    15,    17,    19,
    22,    25,    31,    38,    42,    44,    48,    52,    55,    56,
    62,    66,    68,    72,    76,    80,    82,    86,    90,    91,
    92,   101,   102,   105,   106,   114,   115,   123,   125,   129,
   132,   135,   140,   147,   152,   153,   157,   164,   173,   181,
   188,   191,   193,   194,   195,   204,   205,   208,   214,   220,
   223,   227,   228,   229,   237,   238,   246,   247,   250,   253,
   254,   259,   262,   264,   267,   269,   273,   274,   283,   284,
   288,   291,   293,   294,   298,   302,   305,   307,   308,   312,
   314,   315,   319,   322,   323,   325,   327,   329,   331,   335,
   337,   339,   341,   343,   347,   349,   351,   355,   360,   364,
   367,   369,   372,   374,   380,   384,   385,   387,   389,   391,
   393,   396,   398
};

static const short yyrhs[] = {    43,
     0,    42,    43,     0,    44,     0,    45,     0,    52,     0,
    55,     0,    67,     0,    74,     0,    81,     0,     1,    14,
     0,     1,    12,     0,    97,     6,    95,    39,    14,     0,
    97,     6,    95,    39,    95,    14,     0,     7,    46,    14,
     0,    47,     0,    46,    16,    47,     0,    19,    39,    95,
     0,    39,    95,     0,     0,    39,    95,    17,    48,    49,
     0,    25,    50,    26,     0,    51,     0,    50,    16,    51,
     0,    39,    17,    38,     0,     8,    53,    14,     0,    54,
     0,    53,    16,    54,     0,    39,    17,    38,     0,     0,
     0,     9,    39,    25,    56,    58,    57,    26,    14,     0,
     0,    58,    59,     0,     0,    60,    62,    17,    25,    64,
    26,    14,     0,     0,    61,    24,    17,    25,    64,    26,
    14,     0,    63,     0,    62,    16,    63,     0,    20,    38,
     0,    18,    38,     0,    27,    20,    38,    28,     0,    18,
    38,    27,    20,    38,    28,     0,    27,    18,    38,    28,
     0,     0,    64,    65,    14,     0,    21,    38,    96,    17,
    38,    96,     0,    21,    38,    96,    17,    18,    38,    66,
    96,     0,    21,    38,    96,    17,    18,    38,    96,     0,
    21,    38,    96,    17,    20,    38,     0,    22,    38,     0,
    22,     0,     0,     0,    10,    39,    25,    68,    70,    69,
    26,    14,     0,     0,    70,    71,     0,     5,    94,    15,
    94,    14,     0,     5,    94,    15,    65,    14,     0,    65,
    14,     0,     9,    39,    14,     0,     0,     0,     9,    25,
    72,    58,    73,    26,    14,     0,     0,    11,     3,    22,
    38,    75,    76,    12,     0,     0,    76,    77,     0,    79,
    14,     0,     0,    98,    78,    79,    14,     0,     1,    14,
     0,    80,     0,    79,    80,     0,    94,     0,    94,    17,
    94,     0,     0,    11,     4,    22,    38,    82,    13,    83,
    12,     0,     0,    83,    84,    13,     0,     1,    13,     0,
    86,     0,     0,    98,    85,    86,     0,    98,    34,    38,
     0,    36,    39,     0,    37,     0,     0,    39,    87,    92,
     0,    39,     0,     0,    89,    88,    90,     0,    35,    38,
     0,     0,    33,     0,    31,     0,    32,     0,    91,     0,
    90,    16,    91,     0,    38,     0,    39,     0,    41,     0,
    93,     0,    92,    16,    93,     0,    94,     0,    99,     0,
    27,    99,    28,     0,    94,    27,    99,    28,     0,    27,
    94,    28,     0,    18,    38,     0,    38,     0,    18,    39,
     0,    39,     0,    29,    38,    15,    38,    30,     0,    29,
    38,    30,     0,     0,    95,     0,     3,     0,     4,     0,
     5,     0,    39,    15,     0,    40,     0,    20,    40,     0
};

#endif

#if YYDEBUG != 0
static const short yyrline[] = { 0,
    46,    47,    50,    51,    52,    53,    54,    55,    56,    57,
    58,    64,    65,    71,    74,    75,    78,    79,    80,    81,
    83,    86,    87,    90,    96,    99,   100,   103,   108,   109,
   109,   112,   113,   116,   116,   117,   117,   121,   122,   125,
   126,   127,   128,   129,   132,   133,   136,   137,   138,   139,
   142,   143,   149,   149,   149,   152,   153,   156,   157,   158,
   159,   160,   161,   161,   167,   167,   170,   171,   174,   175,
   175,   176,   179,   180,   183,   184,   192,   193,   196,   197,
   198,   201,   202,   203,   203,   204,   205,   208,   209,   209,
   210,   211,   211,   212,   215,   216,   217,   220,   221,   224,
   225,   226,   229,   230,   233,   234,   235,   236,   237,   240,
   241,   242,   243,   249,   250,   253,   254,   257,   258,   259,
   262,   265,   266
};
#endif


#if YYDEBUG != 0 || defined (YYERROR_VERBOSE)

static const char * const yytname[] = {   "$","error","$undefined.","MICROCODE",
"MACROCODE","MAP","BANK","FIELD","REGISTERS","OPERANDS","OP","KWBEGIN","KWEND",
"NL","SEMI","COLON","COMMA","ASGN","HASH","TILDE","PERCENT","PLUS","AT","BOGOCHAR",
"MINUS","LBRACE","RBRACE","LPAREN","RPAREN","LBRACK","RBRACK","DSHORT","DLONG",
"DBYTE","DSYMBOL","DBSS","DPROC","DEND","NUMBER","LITERAL","REGISTER","STRING",
"prog","top_item","bank_decl","field_decl","fitems","fitem","@1","enumset","eitems",
"eitem","reg_decl","regs","reg","operand_decl","@2","@3","operdefs","operdef",
"@4","@5","oprlhss","oprlhs","opasgns","opasgn","offset","op_decl","@6","@7",
"opditems","opditem","@8","@9","ucode","@10","uops","uop","@11","uspecs","uspec",
"mcode","@12","mops","lmop","@13","mop","@14","@15","dtype","bsl_items","bsl_item",
"operands","operand","number","brange","obrange","what","label","register", NULL
};
#endif

static const short yyr1[] = {     0,
    42,    42,    43,    43,    43,    43,    43,    43,    43,    43,
    43,    44,    44,    45,    46,    46,    47,    47,    48,    47,
    49,    50,    50,    51,    52,    53,    53,    54,    56,    57,
    55,    58,    58,    60,    59,    61,    59,    62,    62,    63,
    63,    63,    63,    63,    64,    64,    65,    65,    65,    65,
    66,    66,    68,    69,    67,    70,    70,    71,    71,    71,
    71,    72,    73,    71,    75,    74,    76,    76,    77,    78,
    77,    77,    79,    79,    80,    80,    82,    81,    83,    83,
    83,    84,    85,    84,    84,    84,    84,    87,    86,    86,
    88,    86,    86,    86,    89,    89,    89,    90,    90,    91,
    91,    91,    92,    92,    93,    93,    93,    93,    93,    94,
    94,    94,    94,    95,    95,    96,    96,    97,    97,    97,
    98,    99,    99
};

static const short yyr2[] = {     0,
     1,     2,     1,     1,     1,     1,     1,     1,     1,     2,
     2,     5,     6,     3,     1,     3,     3,     2,     0,     5,
     3,     1,     3,     3,     3,     1,     3,     3,     0,     0,
     8,     0,     2,     0,     7,     0,     7,     1,     3,     2,
     2,     4,     6,     4,     0,     3,     6,     8,     7,     6,
     2,     1,     0,     0,     8,     0,     2,     5,     5,     2,
     3,     0,     0,     7,     0,     7,     0,     2,     2,     0,
     4,     2,     1,     2,     1,     3,     0,     8,     0,     3,
     2,     1,     0,     3,     3,     2,     1,     0,     3,     1,
     0,     3,     2,     0,     1,     1,     1,     1,     3,     1,
     1,     1,     1,     3,     1,     1,     3,     4,     3,     2,
     1,     2,     1,     5,     3,     0,     1,     1,     1,     1,
     2,     1,     2
};

static const short yydefact[] = {     0,
     0,   118,   119,   120,     0,     0,     0,     0,     0,     0,
     1,     3,     4,     5,     6,     7,     8,     9,     0,    11,
    10,     0,     0,     0,    15,     0,     0,    26,     0,     0,
     0,     0,     2,     0,     0,     0,    18,    14,     0,     0,
    25,     0,    29,    53,     0,     0,     0,    17,     0,    19,
    16,    28,    27,    32,    56,    65,    77,     0,     0,   115,
     0,    34,    54,    67,     0,    12,     0,     0,     0,    20,
     0,    33,     0,     0,     0,     0,     0,     0,     0,    57,
     0,     0,    13,   114,     0,     0,    22,     0,     0,     0,
     0,     0,    38,     0,     0,   111,   113,     0,    62,     0,
   116,    60,     0,     0,    66,   113,    68,     0,    73,    75,
    70,     0,    94,     0,     0,    21,    31,    41,    40,     0,
     0,     0,     0,     0,   110,   112,     0,    32,    61,   117,
     0,    55,    72,   121,    69,    74,     0,     0,    81,    78,
    96,    97,    95,     0,     0,    87,    88,     0,    82,    91,
    83,    24,    23,     0,     0,     0,    39,    45,    45,     0,
     0,    34,     0,    76,     0,    93,    86,     0,    80,     0,
     0,    94,     0,    44,    42,     0,     0,    59,    58,     0,
     0,     0,   116,    71,     0,     0,   122,    89,   103,   105,
   106,   100,   101,   102,    92,    98,    85,    88,    84,     0,
     0,     0,     0,     0,   116,    50,    47,   123,     0,     0,
     0,     0,     0,    43,    35,    46,    37,    64,    52,   116,
    49,   109,   107,   104,     0,    99,    51,    48,   108,     0,
     0
};

static const short yydefgoto[] = {    10,
    11,    12,    13,    24,    25,    61,    70,    86,    87,    14,
    27,    28,    15,    54,    71,    62,    72,    73,    74,    92,
    93,   176,   202,   220,    16,    55,    79,    63,    80,   128,
   180,    17,    64,    81,   107,   138,   108,   109,    18,    65,
   113,   148,   172,   149,   168,   170,   150,   195,   196,   188,
   189,   110,   130,   131,    19,   111,   191
};

static const short yypact[] = {   109,
    78,-32768,-32768,-32768,    -8,   -22,    42,    63,    23,    96,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,-32768,    76,-32768,
-32768,    69,    65,   117,-32768,    81,   125,-32768,    84,    90,
   113,   121,-32768,    65,    65,   111,   134,-32768,    -8,   119,
-32768,   -22,-32768,-32768,   120,   122,   116,-32768,    59,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,-32768,    66,   123,-32768,
   131,   118,    70,-32768,   146,-32768,   148,   135,   124,-32768,
   138,-32768,   103,   142,    30,   -21,   129,   154,   143,-32768,
     4,     2,-32768,-32768,   153,    -7,-32768,   157,   136,   137,
   127,    55,-32768,   155,   115,-32768,-32768,   158,-32768,   162,
    65,-32768,   163,   164,-32768,   165,-32768,     7,-32768,   166,
-32768,   168,    18,   141,   124,-32768,-32768,   159,-32768,   144,
   147,   103,   167,   169,-32768,-32768,    49,-32768,-32768,-32768,
   170,-32768,-32768,-32768,-32768,-32768,    30,    30,-32768,-32768,
-32768,-32768,-32768,   150,   145,-32768,   133,   176,-32768,-32768,
   156,-32768,-32768,   171,   172,   173,-32768,-32768,-32768,   179,
   181,   126,   -10,-32768,    22,-32768,-32768,    46,-32768,    99,
   160,    93,   161,-32768,-32768,   101,   108,-32768,-32768,   177,
   174,   175,    65,-32768,   178,    38,-32768,   180,-32768,   182,
-32768,-32768,-32768,-32768,   186,-32768,-32768,   184,-32768,   183,
   190,   191,   192,   193,    -9,-32768,-32768,-32768,   187,   188,
    46,    43,    99,-32768,-32768,-32768,-32768,-32768,   185,    65,
-32768,-32768,-32768,-32768,   189,-32768,-32768,-32768,-32768,   208,
-32768
};

static const short yypgoto[] = {-32768,
   200,-32768,-32768,-32768,   194,-32768,-32768,-32768,   104,-32768,
-32768,   195,-32768,-32768,-32768,    86,-32768,-32768,-32768,-32768,
    98,    62,   -62,-32768,-32768,-32768,-32768,-32768,-32768,-32768,
-32768,-32768,-32768,-32768,-32768,-32768,    87,  -106,-32768,-32768,
-32768,-32768,-32768,    50,-32768,-32768,-32768,-32768,    11,-32768,
    15,   -75,   -11,  -176,-32768,   114,  -180
};


#define	YYLAST		237


static const short yytable[] = {    98,
    78,   136,   112,    99,   104,   210,   207,   181,   115,   182,
    22,    37,   219,   -79,   -79,   105,    26,   100,   116,    36,
   135,    95,    47,    48,    95,    31,    32,   183,   221,   140,
    23,   225,   -79,   -79,   -79,   184,   -79,   -79,   -79,    95,
   -79,    96,   106,   228,    96,    97,    67,    95,   141,   142,
   143,   161,   144,   145,   146,    95,   147,   185,   136,    96,
    97,   164,   185,    95,   160,   185,    95,    96,    97,    77,
   122,   123,   186,    59,    75,    96,    97,   187,    76,    66,
    29,    34,   187,    96,    97,   187,    96,    97,    60,    20,
    77,    21,   190,    36,    36,   230,     1,    40,     2,     3,
     4,    30,     5,     6,     7,     8,     9,    35,    43,     1,
   209,     2,     3,     4,    44,     5,     6,     7,     8,     9,
    89,    77,    90,   141,   142,   143,   201,   144,    77,    91,
    38,   198,    39,   203,    45,   190,   192,   193,    41,   194,
    42,   -36,    46,   -30,   120,   -90,   121,   134,    49,   -36,
    50,   -63,   125,   126,    58,    69,    52,    56,    82,    57,
    68,    83,    85,    88,    84,    94,   101,   102,   103,   114,
   117,   124,   127,   118,   119,   129,   132,   133,   152,   134,
   139,   155,   137,   167,   156,   154,   163,   166,   169,   171,
   173,   158,   178,   159,   179,   211,   -90,   197,   200,   174,
   175,   213,   204,   215,   216,   217,   218,   231,   212,    33,
   214,   205,   206,   162,   222,   223,   229,   208,   153,   157,
   177,   199,   227,   226,   165,   224,   151,     0,     0,     0,
     0,     0,    51,     0,     0,     0,    53
};

static const short yycheck[] = {    75,
    63,   108,     1,    25,     1,   186,   183,    18,    16,    20,
    19,    23,    22,    12,    13,    12,    39,    39,    26,    29,
    14,    18,    34,    35,    18,     3,     4,    38,   205,    12,
    39,   212,    31,    32,    33,    14,    35,    36,    37,    18,
    39,    38,    39,   220,    38,    39,    58,    18,    31,    32,
    33,   127,    35,    36,    37,    18,    39,    20,   165,    38,
    39,   137,    20,    18,   127,    20,    18,    38,    39,    21,
    16,    17,    27,    15,     5,    38,    39,    40,     9,    14,
    39,     6,    40,    38,    39,    40,    38,    39,    30,    12,
    21,    14,   168,    29,    29,     0,     1,    17,     3,     4,
     5,    39,     7,     8,     9,    10,    11,    39,    25,     1,
   186,     3,     4,     5,    25,     7,     8,     9,    10,    11,
    18,    21,    20,    31,    32,    33,    26,    35,    21,    27,
    14,    39,    16,    26,    22,   211,    38,    39,    14,    41,
    16,    24,    22,    26,    18,    13,    20,    15,    38,    24,
    17,    26,    38,    39,    39,    25,    38,    38,    13,    38,
    38,    14,    39,    26,    30,    24,    38,    14,    26,    17,
    14,    17,    15,    38,    38,    14,    14,    14,    38,    15,
    13,    38,    17,    39,    38,    27,    17,    38,    13,    34,
    20,    25,    14,    25,    14,    16,    13,    38,    38,    28,
    28,    16,    26,    14,    14,    14,    14,     0,    27,    10,
    28,    38,    38,   128,    28,    28,    28,    40,   115,   122,
   159,   172,    38,   213,   138,   211,   113,    -1,    -1,    -1,
    -1,    -1,    39,    -1,    -1,    -1,    42
};
/* -*-C-*-  Note some compilers choke on comments on `#line' lines.  */
#line 3 "/usr/share/misc/bison.simple"

/* Skeleton output parser for bison,
   Copyright (C) 1984, 1989, 1990 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

#ifndef alloca
#ifdef __GNUC__
#define alloca __builtin_alloca
#else /* not GNU C.  */
#if (!defined (__STDC__) && defined (sparc)) || defined (__sparc__) || defined (__sparc) || defined (__sgi)
#include <alloca.h>
#else /* not sparc */
#if defined (MSDOS) && !defined (__TURBOC__)
#include <malloc.h>
#else /* not MSDOS, or __TURBOC__ */
#if defined(_AIX)
#include <malloc.h>
 #pragma alloca
#else /* not MSDOS, __TURBOC__, or _AIX */
#ifdef __hpux
#ifdef __cplusplus
extern "C" {
void *alloca (unsigned int);
};
#else /* not __cplusplus */
void *alloca ();
#endif /* not __cplusplus */
#endif /* __hpux */
#endif /* not _AIX */
#endif /* not MSDOS, or __TURBOC__ */
#endif /* not sparc.  */
#endif /* not GNU C.  */
#endif /* alloca not defined.  */

/* This is the parser code that is written into each bison parser
  when the %semantic_parser declaration is not specified in the grammar.
  It was written by Richard Stallman by simplifying the hairy parser
  used when %semantic_parser is specified.  */

/* Note: there must be only one dollar sign in this file.
   It is replaced by the list of actions, each action
   as one case of the switch.  */

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		-2
#define YYEOF		0
#define YYACCEPT	return(0)
#define YYABORT 	return(1)
#define YYERROR		goto yyerrlab1
/* Like YYERROR except do call yyerror.
   This remains here temporarily to ease the
   transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */
#define YYFAIL		goto yyerrlab
#define YYRECOVERING()  (!!yyerrstatus)
#define YYBACKUP(token, value) \
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    { yychar = (token), yylval = (value);			\
      yychar1 = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { yyerror ("syntax error: cannot back up"); YYERROR; }	\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

#ifndef YYPURE
#define YYLEX		yylex()
#endif

#ifdef YYPURE
#ifdef YYLSP_NEEDED
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, &yylloc, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval, &yylloc)
#endif
#else /* not YYLSP_NEEDED */
#ifdef YYLEX_PARAM
#define YYLEX		yylex(&yylval, YYLEX_PARAM)
#else
#define YYLEX		yylex(&yylval)
#endif
#endif /* not YYLSP_NEEDED */
#endif

/* If nonreentrant, generate the variables here */

#ifndef YYPURE

int	yychar;			/*  the lookahead symbol		*/
YYSTYPE	yylval;			/*  the semantic value of the		*/
				/*  lookahead symbol			*/

#ifdef YYLSP_NEEDED
YYLTYPE yylloc;			/*  location data for the lookahead	*/
				/*  symbol				*/
#endif

int yynerrs;			/*  number of parse errors so far       */
#endif  /* not YYPURE */

#if YYDEBUG != 0
int yydebug;			/*  nonzero means print parse trace	*/
/* Since this is uninitialized, it does not stop multiple parsers
   from coexisting.  */
#endif

/*  YYINITDEPTH indicates the initial size of the parser's stacks	*/

#ifndef	YYINITDEPTH
#define YYINITDEPTH 200
#endif

/*  YYMAXDEPTH is the maximum size the stacks can grow to
    (effective only if the built-in stack extension method is used).  */

#if YYMAXDEPTH == 0
#undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
#define YYMAXDEPTH 10000
#endif

/* Prevent warning if -Wstrict-prototypes.  */
#ifdef __GNUC__
int yyparse (void);
#endif

#if __GNUC__ > 1		/* GNU C and GNU C++ define this.  */
#define __yy_memcpy(TO,FROM,COUNT)	__builtin_memcpy(TO,FROM,COUNT)
#else				/* not GNU C or C++ */
#ifndef __cplusplus

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (to, from, count)
     char *to;
     char *from;
     int count;
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#else /* __cplusplus */

/* This is the most reliable way to avoid incompatibilities
   in available built-in functions on various systems.  */
static void
__yy_memcpy (char *to, char *from, int count)
{
  register char *f = from;
  register char *t = to;
  register int i = count;

  while (i-- > 0)
    *t++ = *f++;
}

#endif
#endif

#line 196 "/usr/share/misc/bison.simple"

/* The user can define YYPARSE_PARAM as the name of an argument to be passed
   into yyparse.  The argument should have type void *.
   It should actually point to an object.
   Grammar actions can access the variable by casting it
   to the proper pointer type.  */

#ifdef YYPARSE_PARAM
#ifdef __cplusplus
#define YYPARSE_PARAM_ARG void *YYPARSE_PARAM
#define YYPARSE_PARAM_DECL
#else /* not __cplusplus */
#define YYPARSE_PARAM_ARG YYPARSE_PARAM
#define YYPARSE_PARAM_DECL void *YYPARSE_PARAM;
#endif /* not __cplusplus */
#else /* not YYPARSE_PARAM */
#define YYPARSE_PARAM_ARG
#define YYPARSE_PARAM_DECL
#endif /* not YYPARSE_PARAM */

int
yyparse(YYPARSE_PARAM_ARG)
     YYPARSE_PARAM_DECL
{
  register int yystate;
  register int yyn;
  register short *yyssp;
  register YYSTYPE *yyvsp;
  int yyerrstatus;	/*  number of tokens to shift before error messages enabled */
  int yychar1 = 0;		/*  lookahead token as an internal (translated) token number */

  short	yyssa[YYINITDEPTH];	/*  the state stack			*/
  YYSTYPE yyvsa[YYINITDEPTH];	/*  the semantic value stack		*/

  short *yyss = yyssa;		/*  refer to the stacks thru separate pointers */
  YYSTYPE *yyvs = yyvsa;	/*  to allow yyoverflow to reallocate them elsewhere */

#ifdef YYLSP_NEEDED
  YYLTYPE yylsa[YYINITDEPTH];	/*  the location stack			*/
  YYLTYPE *yyls = yylsa;
  YYLTYPE *yylsp;

#define YYPOPSTACK   (yyvsp--, yyssp--, yylsp--)
#else
#define YYPOPSTACK   (yyvsp--, yyssp--)
#endif

  int yystacksize = YYINITDEPTH;

#ifdef YYPURE
  int yychar;
  YYSTYPE yylval;
  int yynerrs;
#ifdef YYLSP_NEEDED
  YYLTYPE yylloc;
#endif
#endif

  YYSTYPE yyval;		/*  the variable used to return		*/
				/*  semantic values from the action	*/
				/*  routines				*/

  int yylen;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Starting parse\n");
#endif

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss - 1;
  yyvsp = yyvs;
#ifdef YYLSP_NEEDED
  yylsp = yyls;
#endif

/* Push a new state, which is found in  yystate  .  */
/* In all cases, when you get here, the value and location stacks
   have just been pushed. so pushing a state here evens the stacks.  */
yynewstate:

  *++yyssp = yystate;

  if (yyssp >= yyss + yystacksize - 1)
    {
      /* Give user a chance to reallocate the stack */
      /* Use copies of these so that the &'s don't force the real ones into memory. */
      YYSTYPE *yyvs1 = yyvs;
      short *yyss1 = yyss;
#ifdef YYLSP_NEEDED
      YYLTYPE *yyls1 = yyls;
#endif

      /* Get the current used size of the three stacks, in elements.  */
      int size = yyssp - yyss + 1;

#ifdef yyoverflow
      /* Each stack pointer address is followed by the size of
	 the data in use in that stack, in bytes.  */
#ifdef YYLSP_NEEDED
      /* This used to be a conditional around just the two extra args,
	 but that might be undefined if yyoverflow is a macro.  */
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yyls1, size * sizeof (*yylsp),
		 &yystacksize);
#else
      yyoverflow("parser stack overflow",
		 &yyss1, size * sizeof (*yyssp),
		 &yyvs1, size * sizeof (*yyvsp),
		 &yystacksize);
#endif

      yyss = yyss1; yyvs = yyvs1;
#ifdef YYLSP_NEEDED
      yyls = yyls1;
#endif
#else /* no yyoverflow */
      /* Extend the stack our own way.  */
      if (yystacksize >= YYMAXDEPTH)
	{
	  yyerror("parser stack overflow");
	  return 2;
	}
      yystacksize *= 2;
      if (yystacksize > YYMAXDEPTH)
	yystacksize = YYMAXDEPTH;
      yyss = (short *) alloca (yystacksize * sizeof (*yyssp));
      __yy_memcpy ((char *)yyss, (char *)yyss1, size * sizeof (*yyssp));
      yyvs = (YYSTYPE *) alloca (yystacksize * sizeof (*yyvsp));
      __yy_memcpy ((char *)yyvs, (char *)yyvs1, size * sizeof (*yyvsp));
#ifdef YYLSP_NEEDED
      yyls = (YYLTYPE *) alloca (yystacksize * sizeof (*yylsp));
      __yy_memcpy ((char *)yyls, (char *)yyls1, size * sizeof (*yylsp));
#endif
#endif /* no yyoverflow */

      yyssp = yyss + size - 1;
      yyvsp = yyvs + size - 1;
#ifdef YYLSP_NEEDED
      yylsp = yyls + size - 1;
#endif

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Stack size increased to %d\n", yystacksize);
#endif

      if (yyssp >= yyss + yystacksize - 1)
	YYABORT;
    }

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Entering state %d\n", yystate);
#endif

  goto yybackup;
 yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* yychar is either YYEMPTY or YYEOF
     or a valid token in external form.  */

  if (yychar == YYEMPTY)
    {
#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Reading a token: ");
#endif
      yychar = YYLEX;
    }

  /* Convert token to internal form (in yychar1) for indexing tables with */

  if (yychar <= 0)		/* This means end of input. */
    {
      yychar1 = 0;
      yychar = YYEOF;		/* Don't call YYLEX any more */

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Now at end of input.\n");
#endif
    }
  else
    {
      yychar1 = YYTRANSLATE(yychar);

#if YYDEBUG != 0
      if (yydebug)
	{
	  fprintf (stderr, "Next token is %d (%s", yychar, yytname[yychar1]);
	  /* Give the individual parser a way to print the precise meaning
	     of a token, for further debugging info.  */
#ifdef YYPRINT
	  YYPRINT (stderr, yychar, yylval);
#endif
	  fprintf (stderr, ")\n");
	}
#endif
    }

  yyn += yychar1;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != yychar1)
    goto yydefault;

  yyn = yytable[yyn];

  /* yyn is what to do for this token type in this state.
     Negative => reduce, -yyn is rule number.
     Positive => shift, yyn is new state.
       New state is final state => don't bother to shift,
       just return success.
     0, or most negative number => error.  */

  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrlab;

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting token %d (%s), ", yychar, yytname[yychar1]);
#endif

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  /* count tokens shifted since error; after three, turn off error status.  */
  if (yyerrstatus) yyerrstatus--;

  yystate = yyn;
  goto yynewstate;

/* Do the default action for the current state.  */
yydefault:

  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;

/* Do a reduction.  yyn is the number of a rule to reduce with.  */
yyreduce:
  yylen = yyr2[yyn];
  if (yylen > 0)
    yyval = yyvsp[1-yylen]; /* implement default value of the action */

#if YYDEBUG != 0
  if (yydebug)
    {
      int i;

      fprintf (stderr, "Reducing via rule %d (line %d), ",
	       yyn, yyrline[yyn]);

      /* Print the symbols being reduced, and their result.  */
      for (i = yyprhs[yyn]; yyrhs[i] > 0; i++)
	fprintf (stderr, "%s ", yytname[yyrhs[i]]);
      fprintf (stderr, " -> %s\n", yytname[yyr1[yyn]]);
    }
#endif


  switch (yyn) {

case 10:
#line 57 "grammar.y"
{ yyerrok; ;
    break;}
case 11:
#line 58 "grammar.y"
{ yyerrok; ;
    break;}
case 12:
#line 64 "grammar.y"
{ ycBank(yyvsp[-4].I,&yyvsp[-2].R,yyvsp[-1].S,0); ;
    break;}
case 13:
#line 65 "grammar.y"
{ ycBank(yyvsp[-5].I,&yyvsp[-3].R,yyvsp[-2].S,&yyvsp[-1].R); ;
    break;}
case 17:
#line 78 "grammar.y"
{ ycField(yyvsp[-1].S,&yyvsp[0].R,1); ;
    break;}
case 18:
#line 79 "grammar.y"
{ ycField(yyvsp[-1].S,&yyvsp[0].R,0); ;
    break;}
case 19:
#line 80 "grammar.y"
{ ycField(yyvsp[-2].S,&yyvsp[-1].R,0); ;
    break;}
case 24:
#line 90 "grammar.y"
{ ycEnum(yyvsp[-2].S,yyvsp[0].I); ;
    break;}
case 28:
#line 103 "grammar.y"
{ ycRegRecord(yyvsp[-2].S,yyvsp[0].I); ;
    break;}
case 29:
#line 108 "grammar.y"
{ ycBeginOprGroup(yyvsp[-1].S); ;
    break;}
case 30:
#line 109 "grammar.y"
{ ycEndOprGroup(); ;
    break;}
case 34:
#line 116 "grammar.y"
{ycBeginOperand();;
    break;}
case 35:
#line 116 "grammar.y"
{ycEndOperand();;
    break;}
case 36:
#line 117 "grammar.y"
{ycBeginOperand();;
    break;}
case 37:
#line 117 "grammar.y"
{ycEndOperand();;
    break;}
case 40:
#line 125 "grammar.y"
{ ycOLHS(AM_DIRECT,yyvsp[0].I,0); ;
    break;}
case 41:
#line 126 "grammar.y"
{ ycOLHS(AM_IMMEDIATE,0,yyvsp[0].I); ;
    break;}
case 42:
#line 127 "grammar.y"
{ ycOLHS(AM_INDIRECT,yyvsp[-1].I,0); ;
    break;}
case 43:
#line 128 "grammar.y"
{ ycOLHS(AM_INDEXED,yyvsp[-1].I,yyvsp[-4].I); ;
    break;}
case 44:
#line 129 "grammar.y"
{ ycOLHS(AM_IMMIND,0,yyvsp[-1].I); ;
    break;}
case 47:
#line 136 "grammar.y"
{ ycORHS(OI_DATA,yyvsp[-4].I,&yyvsp[-3].R,yyvsp[-1].I,&yyvsp[0].R,0); yyval.I = yyvsp[-1].I; ;
    break;}
case 48:
#line 137 "grammar.y"
{ ycORHS(OI_RELNUMOP,yyvsp[-6].I,&yyvsp[-5].R,yyvsp[-2].I,&yyvsp[0].R,yyvsp[-1].I); yyval.I = 0; ;
    break;}
case 49:
#line 138 "grammar.y"
{ ycORHS(OI_NUMOP,yyvsp[-5].I,&yyvsp[-4].R,yyvsp[-1].I,&yyvsp[0].R,0); yyval.I = 0; ;
    break;}
case 50:
#line 139 "grammar.y"
{ ycORHS(OI_REGOP,yyvsp[-4].I,&yyvsp[-3].R,yyvsp[0].I,0,0); yyval.I = 0; ;
    break;}
case 51:
#line 142 "grammar.y"
{ yyval.I = yyvsp[0].I; ;
    break;}
case 52:
#line 143 "grammar.y"
{ yyval.I = 0; ;
    break;}
case 53:
#line 149 "grammar.y"
{ ycBeginOp(yyvsp[-1].S); ;
    break;}
case 54:
#line 149 "grammar.y"
{ ycEndOp(); ;
    break;}
case 58:
#line 156 "grammar.y"
{ ycMap(&yyvsp[-3].N,&yyvsp[-1].N); ;
    break;}
case 59:
#line 157 "grammar.y"
{ Number N; N.v.d = yyvsp[-1].I; N.ntype = NT_VALUE; ycMap(&yyvsp[-3].N,&N); ;
    break;}
case 60:
#line 158 "grammar.y"
{ ;
    break;}
case 61:
#line 159 "grammar.y"
{ ycAddOprGroup(yyvsp[-1].S); ;
    break;}
case 62:
#line 160 "grammar.y"
{ ycBeginOprGroup(0); ;
    break;}
case 63:
#line 161 "grammar.y"
{ ycEndOprGroup(); ;
    break;}
case 65:
#line 167 "grammar.y"
{ ycBeginUCode(yyvsp[0].I); ;
    break;}
case 66:
#line 167 "grammar.y"
{ ycEndUCode(); ;
    break;}
case 68:
#line 171 "grammar.y"
{ ycUNext(); ;
    break;}
case 70:
#line 175 "grammar.y"
{ ycULabel(yyvsp[0].S); ;
    break;}
case 72:
#line 176 "grammar.y"
{ yyerrok; ;
    break;}
case 75:
#line 183 "grammar.y"
{ ycUSpec(&yyvsp[0].N,0); ;
    break;}
case 76:
#line 184 "grammar.y"
{ ycUSpec(&yyvsp[-2].N,&yyvsp[0].N); ;
    break;}
case 77:
#line 192 "grammar.y"
{ BeginMA(); ycBeginMCode(yyvsp[0].I); ;
    break;}
case 78:
#line 193 "grammar.y"
{ ycEndMCode(); BeginBA(); ;
    break;}
case 80:
#line 197 "grammar.y"
{ ycMNext(); ;
    break;}
case 81:
#line 198 "grammar.y"
{ yyerrok; ;
    break;}
case 83:
#line 202 "grammar.y"
{ ycMLabel(yyvsp[0].S); ;
    break;}
case 85:
#line 203 "grammar.y"
{ ycMSymbol(yyvsp[-2].S,yyvsp[0].I); ;
    break;}
case 86:
#line 204 "grammar.y"
{ ycBeginProc(yyvsp[0].S); ;
    break;}
case 87:
#line 205 "grammar.y"
{ ycEndProc(); ;
    break;}
case 88:
#line 208 "grammar.y"
{ ycMOp(yyvsp[0].S); ;
    break;}
case 90:
#line 209 "grammar.y"
{ ycMOp(yyvsp[0].S); ;
    break;}
case 91:
#line 210 "grammar.y"
{ ycData(yyvsp[0].I); ;
    break;}
case 93:
#line 211 "grammar.y"
{ ycBss(yyvsp[0].I); ;
    break;}
case 95:
#line 215 "grammar.y"
{ yyval.I = yyvsp[0].I; ;
    break;}
case 96:
#line 216 "grammar.y"
{ yyval.I = yyvsp[0].I; ;
    break;}
case 97:
#line 217 "grammar.y"
{ yyval.I = yyvsp[0].I; ;
    break;}
case 100:
#line 224 "grammar.y"
{ ycDataNum(yyvsp[0].I); ;
    break;}
case 101:
#line 225 "grammar.y"
{ ycDataLit(yyvsp[0].S); ;
    break;}
case 102:
#line 226 "grammar.y"
{ ycDataStr(yyvsp[0].S); ;
    break;}
case 105:
#line 233 "grammar.y"
{ ycMOperand(AM_IMMEDIATE,Number_copy(&yyvsp[0].N),0); ;
    break;}
case 106:
#line 234 "grammar.y"
{ ycMOperand(AM_DIRECT,0,yyvsp[0].I); ;
    break;}
case 107:
#line 235 "grammar.y"
{ ycMOperand(AM_INDIRECT,0,yyvsp[-1].I); ;
    break;}
case 108:
#line 236 "grammar.y"
{ ycMOperand(AM_INDEXED,Number_copy(&yyvsp[-3].N),yyvsp[-1].I); ;
    break;}
case 109:
#line 237 "grammar.y"
{ ycMOperand(AM_IMMIND,Number_copy(&yyvsp[-1].N),0); ;
    break;}
case 110:
#line 240 "grammar.y"
{ yyval.N.ntype = NT_VALUE; yyval.N.v.d = yyvsp[0].I; ;
    break;}
case 111:
#line 241 "grammar.y"
{ yyval.N.ntype = NT_VALUE; yyval.N.v.d = yyvsp[0].I; ;
    break;}
case 112:
#line 242 "grammar.y"
{ yyval.N.ntype = NT_SYMBOL; yyval.N.v.s = yyvsp[0].S; ;
    break;}
case 113:
#line 243 "grammar.y"
{ yyval.N.ntype = NT_SYMBOL; yyval.N.v.s = yyvsp[0].S; ;
    break;}
case 114:
#line 249 "grammar.y"
{ yyval.R.msb = yyvsp[-3].I; yyval.R.lsb = yyvsp[-1].I; ;
    break;}
case 115:
#line 250 "grammar.y"
{ yyval.R.msb = yyval.R.lsb = yyvsp[-1].I; ;
    break;}
case 116:
#line 253 "grammar.y"
{ yyval.R.msb = yyval.R.lsb = -1; ;
    break;}
case 117:
#line 254 "grammar.y"
{ yyval.R = yyvsp[0].R; ;
    break;}
case 118:
#line 257 "grammar.y"
{ yyval.I = yyvsp[0].I; ;
    break;}
case 119:
#line 258 "grammar.y"
{ yyval.I = yyvsp[0].I; ;
    break;}
case 120:
#line 259 "grammar.y"
{ yyval.I = yyvsp[0].I; ;
    break;}
case 121:
#line 262 "grammar.y"
{ yyval.S = yyvsp[-1].S; ;
    break;}
case 122:
#line 265 "grammar.y"
{ yyval.I = yyvsp[0].I; ;
    break;}
case 123:
#line 266 "grammar.y"
{ yyval.I = yyvsp[0].I; ;
    break;}
}
   /* the action file gets copied in in place of this dollarsign */
#line 498 "/usr/share/misc/bison.simple"

  yyvsp -= yylen;
  yyssp -= yylen;
#ifdef YYLSP_NEEDED
  yylsp -= yylen;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

  *++yyvsp = yyval;

#ifdef YYLSP_NEEDED
  yylsp++;
  if (yylen == 0)
    {
      yylsp->first_line = yylloc.first_line;
      yylsp->first_column = yylloc.first_column;
      yylsp->last_line = (yylsp-1)->last_line;
      yylsp->last_column = (yylsp-1)->last_column;
      yylsp->text = 0;
    }
  else
    {
      yylsp->last_line = (yylsp+yylen-1)->last_line;
      yylsp->last_column = (yylsp+yylen-1)->last_column;
    }
#endif

  /* Now "shift" the result of the reduction.
     Determine what state that goes to,
     based on the state we popped back to
     and the rule number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTBASE] + *yyssp;
  if (yystate >= 0 && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTBASE];

  goto yynewstate;

yyerrlab:   /* here on detecting error */

  if (! yyerrstatus)
    /* If not already recovering from an error, report this error.  */
    {
      ++yynerrs;

#ifdef YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (yyn > YYFLAG && yyn < YYLAST)
	{
	  int size = 0;
	  char *msg;
	  int x, count;

	  count = 0;
	  /* Start X at -yyn if nec to avoid negative indexes in yycheck.  */
	  for (x = (yyn < 0 ? -yyn : 0);
	       x < (sizeof(yytname) / sizeof(char *)); x++)
	    if (yycheck[x + yyn] == x)
	      size += strlen(yytname[x]) + 15, count++;
	  msg = (char *) malloc(size + 15);
	  if (msg != 0)
	    {
	      strcpy(msg, "parse error");

	      if (count < 5)
		{
		  count = 0;
		  for (x = (yyn < 0 ? -yyn : 0);
		       x < (sizeof(yytname) / sizeof(char *)); x++)
		    if (yycheck[x + yyn] == x)
		      {
			strcat(msg, count == 0 ? ", expecting `" : " or `");
			strcat(msg, yytname[x]);
			strcat(msg, "'");
			count++;
		      }
		}
	      yyerror(msg);
	      free(msg);
	    }
	  else
	    yyerror ("parse error; also virtual memory exceeded");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror("parse error");
    }

  goto yyerrlab1;
yyerrlab1:   /* here on error raised explicitly by an action */

  if (yyerrstatus == 3)
    {
      /* if just tried and failed to reuse lookahead token after an error, discard it.  */

      /* return failure if at end of input */
      if (yychar == YYEOF)
	YYABORT;

#if YYDEBUG != 0
      if (yydebug)
	fprintf(stderr, "Discarding token %d (%s).\n", yychar, yytname[yychar1]);
#endif

      yychar = YYEMPTY;
    }

  /* Else will try to reuse lookahead token
     after shifting the error token.  */

  yyerrstatus = 3;		/* Each real token shifted decrements this */

  goto yyerrhandle;

yyerrdefault:  /* current state does not do anything special for the error token. */

#if 0
  /* This is wrong; only states that explicitly want error tokens
     should shift them.  */
  yyn = yydefact[yystate];  /* If its default is to accept any token, ok.  Otherwise pop it.*/
  if (yyn) goto yydefault;
#endif

yyerrpop:   /* pop the current state because it cannot handle the error token */

  if (yyssp == yyss) YYABORT;
  yyvsp--;
  yystate = *--yyssp;
#ifdef YYLSP_NEEDED
  yylsp--;
#endif

#if YYDEBUG != 0
  if (yydebug)
    {
      short *ssp1 = yyss - 1;
      fprintf (stderr, "Error: state stack now");
      while (ssp1 != yyssp)
	fprintf (stderr, " %d", *++ssp1);
      fprintf (stderr, "\n");
    }
#endif

yyerrhandle:

  yyn = yypact[yystate];
  if (yyn == YYFLAG)
    goto yyerrdefault;

  yyn += YYTERROR;
  if (yyn < 0 || yyn > YYLAST || yycheck[yyn] != YYTERROR)
    goto yyerrdefault;

  yyn = yytable[yyn];
  if (yyn < 0)
    {
      if (yyn == YYFLAG)
	goto yyerrpop;
      yyn = -yyn;
      goto yyreduce;
    }
  else if (yyn == 0)
    goto yyerrpop;

  if (yyn == YYFINAL)
    YYACCEPT;

#if YYDEBUG != 0
  if (yydebug)
    fprintf(stderr, "Shifting error token, ");
#endif

  *++yyvsp = yylval;
#ifdef YYLSP_NEEDED
  *++yylsp = yylloc;
#endif

  yystate = yyn;
  goto yynewstate;
}
#line 268 "grammar.y"
